<?php
use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\Exception;

require 'vendor/PHPMailer/PHPMailer.php';
require 'vendor/PHPMailer/SMTP.php';
require 'vendor/PHPMailer/Exception.php';

header('Content-Type: application/json');
header("Access-Control-Allow-Origin: *"); 
header("Access-Control-Allow-Methods: POST"); 
header("Access-Control-Allow-Headers: Content-Type, Authorization"); 
header("Content-Type: application/json; charset=UTF-8");

include 'config.php';

$conn = connect(); 

// Retrieve and sanitize input
$data = json_decode(file_get_contents("php://input"), true);

if (isset($data["name"]) && isset($data["email"]) && isset($data["number"]) && isset($data["career_field"]) && isset($data["years_of_experience"]) && isset($data["membership_type"]) && isset($data["password"])) {
    // Retrieve and sanitize input
    $name = $conn->real_escape_string($data["name"]);
    $email = $conn->real_escape_string($data["email"]);
    $number = $conn->real_escape_string($data["number"]);
    $career_field = $conn->real_escape_string($data["career_field"]);
    $years_of_experience = $conn->real_escape_string($data["years_of_experience"]); 
    $membership_type = $conn->real_escape_string($data["membership_type"]);
    $password = password_hash($data["password"], PASSWORD_BCRYPT); 

    // Check if any field is empty
    if (empty($name) || empty($email) || empty($number) || empty($career_field) || empty($years_of_experience) || empty($membership_type) || empty($data["password"])) {
        echo json_encode(["success" => false, "message" => "All fields are required."]);
        http_response_code(400); // Bad Request
        exit();
    }

    // Check if email or number already exists
    $checkSql = "SELECT * FROM users WHERE email = '$email' OR number = '$number'";
    $result = $conn->query($checkSql);
    
    if ($result->num_rows > 0) {
        echo json_encode(["success" => false, "message" => "Email or phone number already exists"]);
        http_response_code(409); // Conflict
        exit();
    }

    // Insert data into the users table
    $sql = "INSERT INTO users (name, email, number, membership_type, years_of_experience, career_field, password) VALUES ('$name', '$email', '$number', '$membership_type', '$years_of_experience', '$career_field', '$password')";


    if ($conn->query($sql) === TRUE) {
        // Send welcome email
        $mail = new PHPMailer(true);
        try {
            // Brevo SMTP settings
            $mail->isSMTP();
            $mail->Host = 'smtp-relay.brevo.com';
            $mail->SMTPAuth = true;
            $mail->Username = 'ddegreeproject@gmail.com';
            $mail->Password = 'xsmtpsib-d219e2013a5ce1bf42ada0609e149db7e26554fb5f13d446ddf4e891909d4291-4YxQIdg7053fpGkM';
            $mail->SMTPSecure = PHPMailer::ENCRYPTION_STARTTLS;
            $mail->Port = 587;

            // Recipients
            $mail->setFrom('no-reply@nde.ng', 'Institute of Management Consultants - Nigeria (IMC)');
            $mail->addAddress($email, $name);

            // Email content
            $mail->isHTML(true);
            $mail->Subject = 'Your Account Has Been Created';
            $mail->Body = "
                <div style='max-width: 600px; margin: auto; padding: 20px; font-family: Arial, sans-serif;'>
                    <div style='background: #e9f3ff; padding: 15px; text-align: center;'>
                        <img src='https://ddverifyme.com/api/IMCN%20Logo.png' alt='NDE Logo' style='height: 80px;'>
                    </div>
                    <div style='padding: 20px; background-color: #ffffff; border: 1px solid #e0e0e0;'>
                        <h2>Hello, {$name}</h2>
                        <p>Your account has been successfully created.</p>
                        <p><strong>Username:</strong> {$email}</p>
                        <p><strong>Password:</strong> {$data["password"]}</p>
                        <p>If you did not create an account, no further action is required.</p>
                        <p>To access your account, simply click on the link below or copy and paste it into your browser:</p>
                        <p><a href='https://nderegistrationportal.ng' style='color: #1a73e8;'>https://imcnig.org/</a></p>
                    </div>
                    <div style='background: #e9f3ff; padding: 10px; text-align: center; color: #555; font-size: 12px;'>
                        <p>&copy; 2024 Institute of Management Consultants - Nigeria (IMC). <br/> All rights reserved.</p>
                    </div>
                </div>
            ";

            // Send email
            $mail->send();
            echo json_encode(["success" => true, "message" => "User registered successfully and email sent"]);
            http_response_code(201); // Created
        } catch (Exception $e) {
            echo json_encode(["success" => false, "message" => "User registered but email could not be sent. Error: {$mail->ErrorInfo}"]);
            http_response_code(500); // Internal Server Error
        }
    } else {
        echo json_encode(["success" => false, "message" => "Error: " . $conn->error]);
        http_response_code(500); // Internal Server Error
    }
} else {
    echo json_encode(["success" => false, "message" => "Invalid input"]);
    http_response_code(400); // Bad Request
}

$conn->close();
?>